#define INCL_DOS
#include <os2.h>
#include "wcapi.h"

struct WCatWindowPtrStruct
  {
  WCatBaseWindow *dllp;
  void           *exep;
  } WindowPtr[30];
int WindowPtrOffset=0;

void WCatAddWindowPtr(WCatBaseWindow *p, void *vp)
  {
  WindowPtr[WindowPtrOffset].dllp=p;
  WindowPtr[WindowPtrOffset].exep=vp;
  WindowPtrOffset++;
  }

WCatBaseWindow *lookupWCatWindow(void *vp)
  {
  for (int i=0; i<WindowPtrOffset; i++)
     if (WindowPtr[i].exep==vp)
        return WindowPtr[i].dllp;

  return 0;
  }

BOOL WCEXPORT WCSYSTEM WCatKey(void *win, int scan, int ascii, int shift)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);
  if (w)
     return w->key(scan, ascii, shift);
  else
     return FALSE;
  }

BOOL WCEXPORT WCSYSTEM  WCatB1Click(void *win, int x, int y)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);

  if (w)
     return w->b1click(x, y);
  else
     return FALSE;
  }

BOOL WCEXPORT WCSYSTEM WCatSelected(void *win, int i)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);
  if (w)
     return w->selected(i);
  else
     return FALSE;
  }

BOOL WCEXPORT WCSYSTEM WCatInformIfProcessChanged()
  {
  for (int i=0; i<WindowPtrOffset; i++)
     return WindowPtr[i].dllp->processChanged(0);
  }

BOOL WCEXPORT WCSYSTEM WCatReceiveFocus(void *win)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);
  if (w)
     return w->receiveFocus();
  else
     return FALSE;
  }

BOOL WCEXPORT WCSYSTEM WCatLooseFocus(void *win)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);
  if (w)
     return w->looseFocus();
  else
     return FALSE;
  }

BOOL WCEXPORT WCSYSTEM WCatHandleShow(void *win)
  {
  WCatBaseWindow *w=lookupWCatWindow(win);
  if (w)
     return w->handleShow();
  else
     return FALSE;
  }
